isSpawns = false

function Initialise() -- overwrite the original Initialise function to include new custom SetupMultiplayerWormsAndTeams function
   StartedSuddenDeath = false
   
   SetupScheme()

   --lib_SetupMultiplayerWormsAndTeams()
   isSpawns = true
   Renew_SetupMultiplayerWormsAndTeams()
   
   
   SendMessage("WormManager.Reinitialise")

   lib_SetupMinesAndOildrums() -- do this after worms are set up to get correct worm collision


   local scheme = QueryContainer("GM.SchemeData")
   if scheme.RoundTime == 0 then
      StartSuddenDeath() -- do this after worms are set up to readjust health
      local GameOver = GetData("FCS.GameOver")
      -- do no further processing if sudden death drew the game
      if GameOver ~= 0 then
         return 
      end
   end
   
   if scheme.MineFactoryOn == true then
      SendMessage("GameLogic.CreateRandMineFactory")
   end
   
   if scheme.TelepadsOn == true then
       SendMessage("GameLogic.PlaceTelepads")       
   end
   
   SetData("Camera.StartOfTurnCamera","Default")
   
   SetWormpotModes()
   

   WaitingForStartFirstTurn = false
   StartFirstTurn()
--   Activity = GetData("ObjectCount.Active")
--   if Activity == 0 then
--		WaitingForStartFirstTurn = false
--        StartFirstTurn()
--	else
--		WaitingForStartFirstTurn = true
--	end
end

function Renew_SetupMultiplayerWormsAndTeams()
    WormIndex = 0
	--local spawnIndexStepSize = 10
    --local WormSpawnIndex = 0
    local t_Player = "null"
    GM = QueryContainer("GM.GameInitData")
	local T1_NumOfWorms = GM.T1_NumOfWorms
	local T2_NumOfWorms = GM.T2_NumOfWorms
	local T3_NumOfWorms = GM.T3_NumOfWorms
	local T4_NumOfWorms = GM.T4_NumOfWorms
	
	--Renew_Message("MaxNumOfWorms" .. GM.T1_NumOfWorms)
	if isMaxNumOfWorms == true then
		if GM.NumberOfTeams == 2 then
			T1_NumOfWorms = 8
			T2_NumOfWorms = 8
			spawnIndexStepSize = 8
		elseif GM.NumberOfTeams == 3 then
			T1_NumOfWorms = 5
			T2_NumOfWorms = 5
			T3_NumOfWorms = 5
			spawnIndexStepSize = 6
		elseif GM.NumberOfTeams == 4 then
			T1_NumOfWorms = 4
			T2_NumOfWorms = 4
			T2_NumOfWorms = 4
			T2_NumOfWorms = 4
			spawnIndexStepSize = 4
		end	
	end
    if GM.NumberOfTeams>=1 then 
        if isWUM == true then t_Player = GM.T1_Player else t_Player = 0 end
        Renew_SetupMultiplayerTeam(0, GM.T1_Name, t_Player, T1_NumOfWorms, GM.T1_W1_Name, GM.T1_W2_Name, GM.T1_W3_Name, GM.T1_W4_Name, GM.T1_W5_Name, GM.T1_W6_Name,
            GM.T1_Skill, GM.T1_Grave, GM.T1_Flag, GM.T1_Speech, GM.T1_IsLocal, GM.T1_AlliedGroup, GM.T1_Handicap, GM.T1_HatAttachment, GM.T1_GlassesAttachment, GM.T1_TashAttachment, GM.T1_GlovesAttachment)
    end
    --WormSpawnIndex=WormSpawnIndex+spawnIndexStepSize
    if GM.NumberOfTeams>=2 then
        if isWUM == true then t_Player = GM.T2_Player else t_Player = 0 end
        Renew_SetupMultiplayerTeam(1, GM.T2_Name, t_Player, T2_NumOfWorms, GM.T2_W1_Name, GM.T2_W2_Name, GM.T2_W3_Name, GM.T2_W4_Name, GM.T2_W5_Name, GM.T2_W6_Name,
            GM.T2_Skill, GM.T2_Grave, GM.T2_Flag, GM.T2_Speech, GM.T2_IsLocal, GM.T2_AlliedGroup, GM.T2_Handicap, GM.T2_HatAttachment, GM.T2_GlassesAttachment, GM.T2_TashAttachment, GM.T2_GlovesAttachment)
    end
    --WormSpawnIndex=WormSpawnIndex+spawnIndexStepSize
    if GM.NumberOfTeams>=3 then 
        if isWUM == true then t_Player = GM.T3_Player else t_Player = 0 end
        Renew_SetupMultiplayerTeam(2, GM.T3_Name, t_Player, T3_NumOfWorms, GM.T3_W1_Name, GM.T3_W2_Name, GM.T3_W3_Name, GM.T3_W4_Name, GM.T3_W5_Name, GM.T3_W6_Name,
            GM.T3_Skill, GM.T3_Grave, GM.T3_Flag, GM.T3_Speech, GM.T3_IsLocal, GM.T3_AlliedGroup, GM.T3_Handicap,  GM.T3_HatAttachment, GM.T3_GlassesAttachment, GM.T3_TashAttachment, GM.T3_GlovesAttachment)
    end
    --WormSpawnIndex=WormSpawnIndex+spawnIndexStepSize
    if GM.NumberOfTeams>=4 then 
        if isWUM == true then t_Player = GM.T4_Player else t_Player = 0 end
        Renew_SetupMultiplayerTeam(3, GM.T4_Name, t_Player, T4_NumOfWorms, GM.T4_W1_Name, GM.T4_W2_Name, GM.T4_W3_Name, GM.T4_W4_Name, GM.T4_W5_Name, GM.T4_W6_Name,
            GM.T4_Skill, GM.T4_Grave, GM.T4_Flag, GM.T4_Speech, GM.T4_IsLocal, GM.T4_AlliedGroup, GM.T4_Handicap,  GM.T4_HatAttachment, GM.T4_GlassesAttachment, GM.T4_TashAttachment, GM.T4_GlovesAttachment)
    end
    

end

function Renew_SetupMultiplayerTeam(tIndex,TeamName, PlayerName, NumWorms, Worm1Name, Worm2Name, Worm3Name, Worm4Name, Worm5Name, Worm6Name,
                   Skill, Grave, Flag, Speech, IsLocal, AlliedGroup, Handicap,
                   HatAttachment, GlassesAttachment, TashAttachment, GlovesAttachment)

    local teamSpawnIndex = tIndex * 10
	local wormNames = {Worm1Name,Worm2Name,Worm3Name,Worm4Name,Worm5Name,Worm6Name,Worm1Name,Worm2Name,Worm3Name,Worm4Name}
    local lock, team = EditContainer(lib_GetTeamContainerName(tIndex)) 	
    --WormSpawnIndexA=vWormSpawnIndex
        team.Active = true
        team.Name = TeamName
	    if isWUM == true then team.Player = PlayerName end
        team.TeamColour = 0
        team.Skill = Skill
        team.GraveIndex = Grave
        team.FlagGfxName = Flag
        team.AlliedGroup = AlliedGroup
        team.IsLocal = IsLocal
        team.ATT_Hat = HatAttachment
        team.ATT_Glasses = GlassesAttachment
        team.ATT_Tash = TashAttachment
        team.ATT_Gloves = GlovesAttachment
        if Skill>0 then
            team.IsAIControlled = true
        else
            team.IsAIControlled = false
        end

	   -- PC: added this to reset the win count for the teams if this is the first round played.
        local iRounds = GetData("GameOver.RoundNumber")
        if iRounds == 0 then 
			team.RoundsWon = 0
        end

    CloseContainer(lock) -- must close the container ASAP


   -- factor handicap into deciding worm health
    local scheme = QueryContainer("GM.SchemeData")
    local delta = 0
    if scheme.WormHealth == 50 then
      delta = 25
    elseif scheme.WormHealth == 100 then
      delta = 25
    elseif scheme.WormHealth == 150 then
      delta = 50
    elseif scheme.WormHealth == 200 then
      delta = 100
    end
   -- handicap will be set to either -1,0,1
    local Energy = scheme.WormHealth + (Handicap*delta)
	if isDuel == true then NumWorms = 1 end
	for i = 0,NumWorms-1 do
		--Renew_Message("Try to spawn worm " .. wormNames[i] .. " spawn:" .. teamSpawnIndex + wormSpawnIndex)
		Renew_SetupMultiplayerWorm(tIndex, wormNames[i+1], Speech, Energy, teamSpawnIndex + i)
		--Renew_Message("Worm Spawn OK")
	end
    --wormSpawnIndex=wormSpawnIndex+1
   --RrR = 0
   --WormSpawnIndexA=WormSpawnIndexA+1
end



function Renew_SetupMultiplayerWorm(tIndex, Name, Speech, Energy, wWormSpawnIndex)

   
    local scheme = QueryContainer("GM.SchemeData")
   
    local lock, worm = EditContainer(lib_GetWormContainerName(WormIndex))
		
		--Renew_Message(Name .. " " .. Speech .. " " .. Energy .. " " .. wWormSpawnIndex)
        worm.Active = true
        worm.PlayedInGame = true
        worm.Name = Name
        worm.TeamIndex = tIndex
        worm.SfxBankName = Speech    
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        --Renew_Message("Worm Spawn TEST")
        if isSpawns == true then
            worm.Spawn = Renew_GetWormPosition(wWormSpawnIndex)
        else
            worm.Spawn = "spawn"
        end
        worm.Energy = Energy
        local art = scheme.ArtileryMode
        if art == 0 then
            worm.ArtilleryMode = false
        else
            worm.ArtilleryMode = true
        end

    CloseContainer(lock)
	
    WormIndex = WormIndex +1
end

function Renew_GetWormPosition(Id) -- spawn system 2.0 - WORM0..9 - Team1, WORM10..19 - Team2, Worm20..29 - Team 3, Worm 30..39 - Team 4

	local DataId = { "WORM0", "WORM1", "WORM2", "WORM3", "WORM4", "WORM5", "WORM6", "WORM7", "WORM8", "WORM9", "WORM10", "WORM11", "WORM12", "WORM13", "WORM14", "WORM15", "WORM16", "WORM17", "WORM18", "WORM19", "WORM20", "WORM21", "WORM22", "WORM23", "WORM24", "WORM25", "WORM26",  "WORM27",  "WORM28",  "WORM29", "WORM30", "WORM31", "WORM32", "WORM33", "WORM34", "WORM35", "WORM36", "WORM37", "WORM38", "WORM39","spawn" }
	if Id>40 then
		return DataId[41]
	else
		return DataId[Id+1]
	end
end